Separation <-
function(){
library(epicalc)
library(fields)
library(rgl)
library(graphics)
library(magic)
library(gplots)
wpath<<-"D://PAVLO_FLO"
analyte<<-1

#################################################################################################################################
#modul for extraction of rawdata for arraystrips
#################################################################################################################################

extractdata_strips=function(workpath,substance,run,times,concentrations){						#creates a function with the argument of workpath, Protein of interest and the calibration run

stoffcountingindex=1
daten=list()
for(substance in substance){


paths=Sys.glob(file.path(workpath, "*")) 										#creates a list of folders inheriting the timepointsorted data
paths=sort(paths)

a=list()  														#creates empty table
b=list()  														#creates empty table
neu=list()														#creates empty table

foldernames=list.files(path =paths[1])[-length(list.files(path =paths[1]))]

for(j in foldernames){                        										#first loop to go through the different folders of concentrations
	m=1
	
	for(i in paths[-(1:3)]){     											#go through timepoints without the first three
		a[[m]]=(read.table(paste(i,paste(j,"\\result.txt",sep=""),sep="\\"),header=T,sep="\t"))  		#reading the tables and cut of unneccessary columns
		a[[m]]=a[[m]][,-(c(which(colnames(a[[m]])=="Valid"),which(colnames(a[[m]])=="Background"),which(colnames(a[[m]])=="Mean")))]
		
		analyte=(a[[m]][,2]==substance)
		
		SpotIDs=c(a[[m]][analyte,"Spot.ID"])
				
		a[[m]]=a[[m]][,-(c(which(colnames(a[[m]])=="Spot.ID")))]
		
		a[[m]]=a[[m]][analyte,-(c(which(colnames(a[[m]])=="Confidence")))]
		
		
	m=m+1
	}
	
#go through all the columns an paste rows with equal names together in neu
		
		
			for(g in 1:length(a[[m-1]][,1])){
				neu[[g]]=a[[m-1]][g,]
				for(l in 1:length(paths[-(1:3)])){
						neu[[g]]=rbind(neu[[g]],a[[l]][g,])
				}	
				neu[[g]]=neu[[g]][-(1),]
				}
				
#whrite the different concentrations together in one list		
	b[[j]]=neu
}
#################################################################################################################################
#create table usable for plotting and analysis

d=list()  														#create empty list

#seperate the list entries to the certain datasets

for(r in 1:length(b[[1]])){
	d[[r]]=b[[1]][[r]][,1]
	for(s in 1:length(foldernames)){	
	d[[r]]=cbind(d[[r]],b[[s]][[r]][,2])
	}
	d[[r]]=d[[r]][,-(1)]												#reflect the table and adjust it to rising concentrations
	d[[r]]=arev(d[[r]],2)

	
}
daten[[stoffcountingindex]]=list("name"=substance,"concentrations"=concentrations,"times"=times,"SpotIDs"=SpotIDs,"rawdata"=d)
Blub=daten[[stoffcountingindex]]
stoffcountingindex=stoffcountingindex+1

}
return(daten)
}


#################################################################################################################################
#modul for extraction of confidencevalues for arraystrips
#################################################################################################################################

extractconfidence_strips=function(workpath,substance,run,times,concentrations){					#creates a function with the argument of workpath, Protein of interest and the calibration run

stoffcountingindex=1
daten=list()

for(substance in substance){


paths=Sys.glob(file.path(workpath, "*")) 									#creates a list of folders inheriting the timepointsorted data
paths=sort(paths)

a=list()  													#creates empty table
b=list()  													#creates empty table
neu=list()													#creates empty table

foldernames=list.files(path =paths[1])[-length(list.files(path =paths[1]))]

for(j in foldernames){                        									#first loop to go through the different folders of concentrations
	m=1
	
	for(i in paths[-(1:3)]){     										#go through timepoints without the first three
		a[[m]]=(read.table(paste(i,paste(j,"\\result.txt",sep=""),sep="\\"),header=T,sep="\t")) 	#reading the tables and cut of unneccessary columns
		a[[m]]=a[[m]][,-(c(which(colnames(a[[m]])=="Valid"),which(colnames(a[[m]])=="Background"),which(colnames(a[[m]])=="Mean")))]
		
		analyte=(a[[m]][,2]==substance)
		
		SpotIDs=c(a[[m]][analyte,"Spot.ID"])
				
		a[[m]]=a[[m]][,-(c(which(colnames(a[[m]])=="Spot.ID")))]
		
		a[[m]]=a[[m]][analyte,-(c(which(colnames(a[[m]])=="Signal")))]
		
		
	m=m+1
	}
	
#go through all the columns an paste rows with equal names together in neu
		
	for(g in 1:length(a[[m-1]][,1])){
		neu[[g]]=a[[m-1]][g,]
		for(l in 1:length(paths[-(1:3)])){
			neu[[g]]=rbind(neu[[g]],a[[l]][g,])
		}	
		neu[[g]]=neu[[g]][-(1),]
	}
				
#whrite the different concentrations together in one list		
	b[[j]]=neu
}

#################################################################################################################################
#create table usable for plotting and analysis

d=list()  											#create empty list

#seperate the list entries to the certain datasets

for(r in 1:length(b[[1]])){
	d[[r]]=b[[1]][[r]][,1]
	for(s in 1:length(foldernames)){	
	d[[r]]=cbind(d[[r]],b[[s]][[r]][,2])
	}
	d[[r]]=d[[r]][,-(1)]
	
												#reflect the table and adjust it to rising concentrations

	d[[r]]=arev(d[[r]],2)

	
}
	daten[[stoffcountingindex]]=list("name"=substance,"concentrations"=concentrations,"times"=times,"SpotIDs"=SpotIDs,"confidence"=d)
	Blub=daten[[stoffcountingindex]]
	stoffcountingindex=stoffcountingindex+1

}
return(daten)
}



#################################################################################################################################
#plot timecourses of replicate spots for a certain concentration and choose bad Spot by Kolmogorov-Smirnov test manually
#################################################################################################################################



plotting.timecourses.and.choose.IDs.manually=function(data,substance,confidencevalues,workpath,foldernames){		#creates a functions with the arguments of timeseries, rawdata, Protein of interest, confidencedata)

IDlist=list()													#create an empty list for storing the bad IDs

#search for the data containing the analyte which is suppost to be shown and write the extract the calibrationdata
if(length(data[[1]])>=4){	
	for(i in 1:length(data)){										#go through the data set and search for th on with the correct name
		if(data[[i]]$name==substance){
			count=i
		}
	}

	
farben=rainbow(length(data[[count]]$rawdata))	#creates a colorpalette containing as many colors a Spots are replicated	
times=data[[count]]$times
concentrations=data[[count]]$concentrations
	
#create a graphical interface for choice of bad spot through all concentrations of an analyte	


for(k in 1:ncol(data[[count]]$rawdata[[1]])){						#start the loop for going through the concentrations
calibrationwindow=tktoplevel()	
tktitle(calibrationwindow)="KOMA: Calibration replicate signalvalidation"
#plot the signalvalues of the replicated Spots
plot1=tkrplot(calibrationwindow, function(){	#par()
						plot(times,data[[count]]$rawdata[[1]][,k],sub=paste("actual analyteconcentration is",round(concentrations[k],digits=4),"[ng/ml]"),xlab="time [min]",ylab="signal-intensity",type="n", main=paste("Signaldata for",data[[1]]$name),ylim=c(0,2*max(data[[count]]$rawdata[[1]][,k])))
						for(i in 1:length(data[[count]]$rawdata)){	
							lines(times,data[[count]]$rawdata[[i]][,k],type="l", main=data[[1]]$name,col=farben[i])
							text(x=times[length(times)],y=data[[count]]$rawdata[[i]][length(times),k],labels =data[[count]]$SpotIDs[i],col=farben[i],cex=1.3)
						}
						legend("topleft",legend=data[[count]]$SpotIDs,lty=0,text.col=farben)
					},hscale=2, vscale=2)
#plot the confidencevalues of the replicated Spots
plot2=tkrplot(calibrationwindow, function(){	
						plot(times,confidencevalues[[count]]$confidence[[1]][,k],xlab="time [min]",ylab="confidencevalues",type="n", main=paste("Confidencevalues for",confidencevalues[[1]]$name),ylim=c(0,2*max(confidencevalues[[count]]$confidence[[1]][,k])))
						for(i in 1:length(confidencevalues[[count]]$confidence)){	
							lines(times,confidencevalues[[count]]$confidence[[i]][,k],type="l",col=farben[i])
							text(x=times[length(times)],y=confidencevalues[[count]]$confidence[[i]][length(times),k],labels =confidencevalues[[count]]$SpotIDs[i],col=farben[i],cex=1.3)
						}
						legend("topleft",legend=data[[count]]$SpotIDs,lty=0,text.col=farben)
					},hscale=2, vscale=2)
#plot a window for chossing the Spot by clicking on the Xs		
		y=rep(1,length(data[[count]]$SpotIDs))
		x=seq(1,length(data[[count]]$SpotIDs))
					 
#calculate a Kolmogoroc-Smirnov statistics for comparing all the Timecourse with the timecouse of the opposite mean --> how much does the Spot gives impact to the mean of the Spots
		for(i in 1:length(data[[count]]$rawdata)){					#start a loop to go through the Spots
			index=seq(1,length(data[[count]]$rawdata))				#create a index for the number of the Spots
			value.to.compare=data[[count]]$rawdata[[i]][,k]				#choose the Spot to be tested
			others=index[-i]							#choose al the other Spots
			countingindex=0
#sum up the others build a mean out of them	
				for(z in others){
			 		if(countingindex==0){Sum=data[[count]]$rawdata[[z]][,k]}else{Sum=Sum+data[[count]]$rawdata[[z]][,k]}
			 		countingindex=countingindex+1
			 	}
			mean.value.of.the.others=Sum/countingindex
#perform a KS-Test by comparing ech Spot with the mean of the others
			if(i==1){p.for.ID=round(ks.test(value.to.compare,mean.value.of.the.others)$p.value,digits=3)}else{p.for.ID=c(p.for.ID,round(ks.test(value.to.compare,mean.value.of.the.others)$p.value,digits=3))}
		}
		
		
rbValue1=tclVar("0")
rbValue2=tclVar("0")
rbValue3=tclVar("0")
rbValue4=tclVar("0")
rbValue5=tclVar("0")
rbValue6=tclVar("0")

plot3=tkrplot(calibrationwindow,function(){
			IDs.to.left.out=seq(1:6)[c(tclvalue(rbValue1),tclvalue(rbValue2),tclvalue(rbValue3),tclvalue(rbValue4),tclvalue(rbValue5),tclvalue(rbValue6))==0]
			
			index=seq(1,length(data[[count]]$rawdata))				#create a index for the number of the Spots
			others=index[IDs.to.left.out]						#choose all the other Spots
			countingindex=0
	#sum up the others build a mean out of them	
			for(z in others){
			 	if(countingindex==0){Sum=data[[count]]$rawdata[[z]][,k]}else{Sum=Sum+data[[count]]$rawdata[[z]][,k]}
			 	countingindex=countingindex+1
			 }
				mean.value.of.the.others=Sum/countingindex
		
	#perform a KS-Test by comparing ech Spot with the mean of the others
			
		plot(times,mean.value.of.the.others,xlab="time [min]",ylab="signal-intensity",main=paste("Mean of signaldata for",data[[count]]$rawdataname),cex.main=0.8,type="l",col="red",ylim=c(0,2*max(data[[count]]$rawdata[[1]][,k])))
	})

replot.mean=function(){
	tkrreplot(plot3)
	tkraise(calibrationwindow)
	tkfocus(calibrationwindow)}
	

rb1=tkcheckbutton(calibrationwindow,background="red")
rb2=tkcheckbutton(calibrationwindow,background="yellow")
rb3=tkcheckbutton(calibrationwindow,background="green")
rb4=tkcheckbutton(calibrationwindow,background="cyan")
rb5=tkcheckbutton(calibrationwindow,background="blue")
rb6=tkcheckbutton(calibrationwindow,background="violet")

tkconfigure(rb1,variable=rbValue1,command=replot.mean)	
tkconfigure(rb2,variable=rbValue2,command=replot.mean)	
tkconfigure(rb3,variable=rbValue3,command=replot.mean)	
tkconfigure(rb4,variable=rbValue4,command=replot.mean)	
tkconfigure(rb5,variable=rbValue5,command=replot.mean)	
tkconfigure(rb6,variable=rbValue6,command=replot.mean)	

tkgrid(plot1,plot2,columnspan=1,rowspan=9)
tkgrid(plot3,column=2,row=0,columnspan=3)
tklabel(calibrationwindow,text=" ")



tkgrid(tklabel(calibrationwindow,text="Please choose spot replicates you want to exclude from further analysis!"),column=2,row=1,columnspan=3)
tkgrid(tklabel(calibrationwindow,text=" "),tklabel(calibrationwindow,text=" "),tklabel(calibrationwindow,text=paste("SpotID",data[[count]]$SpotIDs[1])),rb1,tklabel(calibrationwindow,text=paste("KS-p-values",p.for.ID[1])),sticky="nsw",row=2)
tkgrid(tklabel(calibrationwindow,text=" "),tklabel(calibrationwindow,text=" "),tklabel(calibrationwindow,text=paste("SpotID",data[[count]]$SpotIDs[2])),rb2,tklabel(calibrationwindow,text=paste("KS-p-values",p.for.ID[2])),sticky="nsw",row=3)
tkgrid(tklabel(calibrationwindow,text=" "),tklabel(calibrationwindow,text=" "),tklabel(calibrationwindow,text=paste("SpotID",data[[count]]$SpotIDs[3])),rb3,tklabel(calibrationwindow,text=paste("KS-p-values",p.for.ID[3])),sticky="nsw",row=4)
tkgrid(tklabel(calibrationwindow,text=" "),tklabel(calibrationwindow,text=" "),tklabel(calibrationwindow,text=paste("SpotID",data[[count]]$SpotIDs[4])),rb4,tklabel(calibrationwindow,text=paste("KS-p-values",p.for.ID[4])),sticky="nsw",row=5)
tkgrid(tklabel(calibrationwindow,text=" "),tklabel(calibrationwindow,text=" "),tklabel(calibrationwindow,text=paste("SpotID",data[[count]]$SpotIDs[5])),rb5,tklabel(calibrationwindow,text=paste("KS-p-values",p.for.ID[5])),sticky="nsw",row=6)
tkgrid(tklabel(calibrationwindow,text=" "),tklabel(calibrationwindow,text=" "),tklabel(calibrationwindow,text=paste("SpotID",data[[count]]$SpotIDs[6])),rb6,tklabel(calibrationwindow,text=paste("KS-p-values",p.for.ID[6])),sticky="nsw",row=7)
tkgrid(tkbutton(calibrationwindow,text="OK",command=function()tkdestroy(calibrationwindow)),column=3,sticky="nsw")
tkwm.geometry(calibrationwindow,"+0+0")
tkraise(calibrationwindow)
tkfocus(calibrationwindow)
tkwait.window(calibrationwindow)	

	IDs.to.left.out=seq(1:6)[c(tclvalue(rbValue1),tclvalue(rbValue2),tclvalue(rbValue3),tclvalue(rbValue4),tclvalue(rbValue5),tclvalue(rbValue6))==1]
	
#IDs.to.left.out=identify(x, y, labels = rep("O",length(x)), pos = FALSE,n=(length(x)-1), plot = TRUE,offset = 0)
		if(length(IDs.to.left.out)==0){IDs=data[[count]]$SpotIDs}else{IDs=data[[count]]$SpotIDs[-(IDs.to.left.out)]}
#store the choice in the reutrned value of the function
		if(k==1){IDlist[[k]]=IDs}else{IDlist[[k]]=IDs}
}

}else{

	
farben=rainbow(length(data$rawdata))							#creates a colorpalette containing as many colors a Spots are replicated	
times=data$times
concentrations=data$concentrations	
#create a graphical interface for choice of bad spot through all concentrations of an analyte	
if(is.vector(data$rawdata)){
	for(i in 1:length(data$rawdata)){
		data$rawdata[[i]]=as.matrix(data$rawdata[[i]])
	}
}

if(is.vector(confidencevalues$confidence)){
	for(i in 1:length(confidencevalues$confidence)){
		confidencevalues$confidence[[i]]=as.matrix(confidencevalues$confidence[[i]])
	}
}

	for(k in 1:ncol(data$rawdata[[1]])){						#start the loop for going through the concentrations
	calibrationwindow=tktoplevel()	
	tktitle(calibrationwindow)=paste("KOMA: Replicate signalvalidation for ",paste(workpath,foldernames,sep="\\"))
#plot the signalvalues of the replicated Spots
plot1=tkrplot(calibrationwindow, function(){	
		plot(times,data$rawdata[[1]][,k],xlab="time [min]",ylab="signal-intensity",type="n", main=paste("Signaldata for",data$name),ylim=c(0,2*max(data$rawdata[[1]][,k])))
			for(i in 1:length(data$rawdata)){	
				lines(times,data$rawdata[[i]][,k],type="l", main=data$name,col=farben[i])
				text(x=times[length(times)],y=data$rawdata[[i]][length(times),k],labels =data$SpotIDs[i],col=farben[i],cex=1.3)
				}
		legend("topleft",legend=data$SpotIDs,lty=0,text.col=farben)
			},hscale=1.5, vscale=1.5)
#plot the confidencevalues of the replicated Spots
plot2=tkrplot(calibrationwindow, function(){	
		plot(times,confidencevalues$confidence[[1]][,k],xlab="time [min]",ylab="confidencevalues",type="n", main=paste("Confidencevalues for",confidencevalues$name),ylim=c(0,2*max(confidencevalues$confidence[[1]][,k])))
			for(i in 1:length(confidencevalues$confidence)){	
				lines(times,confidencevalues$confidence[[i]][,k],type="l",col=farben[i])
				text(x=times[length(times)],y=confidencevalues$confidence[[i]][length(times),k],labels =confidencevalues$SpotIDs[i],col=farben[i],cex=1.3)
				}
		legend("topleft",legend=data$SpotIDs,lty=0,text.col=farben)
			},hscale=1.5, vscale=1.5)
#plot a window for chossing the Spot by clicking on the Xs		
		y=rep(1,length(data$SpotIDs))
		x=seq(1,length(data$SpotIDs))
			 
#calculate a Kolmogoroc-Smirnov statistics for comparing all the Timecourse with the timecouse of the opposite mean --> how much does the Spot gives impact to the mean of the Spots
		for(i in 1:length(data$rawdata)){					#start a loop to go through the Spots
			index=seq(1,length(data$rawdata))				#create a index for the number of the Spots
			value.to.compare=data$rawdata[[i]][,k]				#choose the Spot to be tested
			others=index[-i]						#choose all the other Spots
			countingindex=0
#sum up the others build a mean out of them	
				for(z in others){
			 		if(countingindex==0){Sum=data$rawdata[[z]][,k]}else{Sum=Sum+data$rawdata[[z]][,k]}
			 		countingindex=countingindex+1
			 	}
			mean.value.of.the.others=Sum/countingindex
#perform a KS-Test by comparing ech Spot with the mean of the others
			if(i==1){p.for.ID=round(ks.test(value.to.compare,mean.value.of.the.others)$p.value,digits=3)}else{p.for.ID=c(p.for.ID,round(ks.test(value.to.compare,mean.value.of.the.others)$p.value,digits=3))}
		}

#print the calculated values in the plot and let the user choose via indetify, which Spots he want to leave out
rbValue1=tclVar("0")
rbValue2=tclVar("0")
rbValue3=tclVar("0")
rbValue4=tclVar("0")
rbValue5=tclVar("0")
rbValue6=tclVar("0")

plot3=tkrplot(calibrationwindow,function(){
			IDs.to.left.out=seq(1:6)[c(tclvalue(rbValue1),tclvalue(rbValue2),tclvalue(rbValue3),tclvalue(rbValue4),tclvalue(rbValue5),tclvalue(rbValue6))==0]
			
			index=seq(1,length(data$rawdata))				#create a index for the number of the Spots
			others=index[IDs.to.left.out]						#choose all the other Spots
			countingindex=0
	#sum up the others build a mean out of them	
			for(z in others){
			 	if(countingindex==0){Sum=data$rawdata[[z]][,k]}else{Sum=Sum+data$rawdata[[z]][,k]}
			 	countingindex=countingindex+1
			 }
				mean.value.of.the.others=Sum/countingindex
		
	#perform a KS-Test by comparing ech Spot with the mean of the others
			
		plot(times,mean.value.of.the.others,xlab="time [min]",ylab="signal-intensity",main=paste("Mean of signaldata for",data$name),cex.main=0.8,type="l",col="red",ylim=c(0,2*max(data$rawdata[[1]][,k])))
	})

replot.mean=function(){
	tkrreplot(plot3)
	tkraise(calibrationwindow)
	tkfocus(calibrationwindow)}
	

rb1=tkcheckbutton(calibrationwindow,background="red")
rb2=tkcheckbutton(calibrationwindow,background="yellow")
rb3=tkcheckbutton(calibrationwindow,background="green")
rb4=tkcheckbutton(calibrationwindow,background="cyan")
rb5=tkcheckbutton(calibrationwindow,background="blue")
rb6=tkcheckbutton(calibrationwindow,background="violet")

tkconfigure(rb1,variable=rbValue1,command=replot.mean)	
tkconfigure(rb2,variable=rbValue2,command=replot.mean)	
tkconfigure(rb3,variable=rbValue3,command=replot.mean)	
tkconfigure(rb4,variable=rbValue4,command=replot.mean)	
tkconfigure(rb5,variable=rbValue5,command=replot.mean)	
tkconfigure(rb6,variable=rbValue6,command=replot.mean)	

tkgrid(plot1,plot2,columnspan=1,rowspan=9)
tkgrid(plot3,column=2,row=0,columnspan=3)
tklabel(calibrationwindow,text=" ")



tkgrid(tklabel(calibrationwindow,text="Please choose spot replicates you want to exclude from further analysis!"),column=2,row=1,columnspan=3)
tkgrid(tklabel(calibrationwindow,text=" "),tklabel(calibrationwindow,text=" "),tklabel(calibrationwindow,text=paste("SpotID",data$SpotIDs[1])),rb1,tklabel(calibrationwindow,text=paste("KS-p-values",p.for.ID[1])),sticky="nsw",row=2)
tkgrid(tklabel(calibrationwindow,text=" "),tklabel(calibrationwindow,text=" "),tklabel(calibrationwindow,text=paste("SpotID",data$SpotIDs[2])),rb2,tklabel(calibrationwindow,text=paste("KS-p-values",p.for.ID[2])),sticky="nsw",row=3)
tkgrid(tklabel(calibrationwindow,text=" "),tklabel(calibrationwindow,text=" "),tklabel(calibrationwindow,text=paste("SpotID",data$SpotIDs[3])),rb3,tklabel(calibrationwindow,text=paste("KS-p-values",p.for.ID[3])),sticky="nsw",row=4)
tkgrid(tklabel(calibrationwindow,text=" "),tklabel(calibrationwindow,text=" "),tklabel(calibrationwindow,text=paste("SpotID",data$SpotIDs[4])),rb4,tklabel(calibrationwindow,text=paste("KS-p-values",p.for.ID[4])),sticky="nsw",row=5)
tkgrid(tklabel(calibrationwindow,text=" "),tklabel(calibrationwindow,text=" "),tklabel(calibrationwindow,text=paste("SpotID",data$SpotIDs[5])),rb5,tklabel(calibrationwindow,text=paste("KS-p-values",p.for.ID[5])),sticky="nsw",row=6)
tkgrid(tklabel(calibrationwindow,text=" "),tklabel(calibrationwindow,text=" "),tklabel(calibrationwindow,text=paste("SpotID",data$SpotIDs[6])),rb6,tklabel(calibrationwindow,text=paste("KS-p-values",p.for.ID[6])),sticky="nsw",row=7)
tkgrid(tkbutton(calibrationwindow,text="OK and plot the result",command=function(){	
								tkdestroy(calibrationwindow)
								plot.graph<<-TRUE
								},background="green"),column=3,row=8,sticky="nsw")
tkgrid(tkbutton(calibrationwindow,text="OK and do not plot the result",command=function(){	
								tkdestroy(calibrationwindow)
								plot.graph<<-FALSE
								},background="red"),column=4,row=8,sticky="nsw")
								
tkwm.geometry(calibrationwindow,"+0+0")
tkraise(calibrationwindow)
tkfocus(calibrationwindow)
tkwait.window(calibrationwindow)	

IDs.to.left.out=seq(1:6)[c(tclvalue(rbValue1),tclvalue(rbValue2),tclvalue(rbValue3),tclvalue(rbValue4),tclvalue(rbValue5),tclvalue(rbValue6))==1]
	
		
		if(length(IDs.to.left.out)==0){IDs=data$SpotIDs}else{IDs=data$SpotIDs[-(IDs.to.left.out)]}
#stor the choice in the reutrned value of the function
		if(k==1){IDlist[[k]]=IDs}else{IDlist[[k]]=IDs}
}


}
	return(IDlist)										#give back the chosen IDs



}



#################################################################################################################################
#plot timecourses of replicate spots for a certain concentration and choose bad Spot by Kolmogorov-Smirnov test automatical
#################################################################################################################################

choose.IDs.automatical=function(data,substance,confidencevalues){ 			#does the same like mentioned above but automatically concerning only about the KS-values

IDlist=list()
	for(i in 1:length(data)){
		if(data[[i]]$name==substance){
			count=i
		}
	}
times=data[[count]]$times
#calculate a Kolmogoroc-Smirnov statistics for comparing all the Timecourse with the timecouse of the opposite mean --> how much does the Spot gives impact to the mean of the Spots
	for(k in 1:ncol(data[[count]]$rawdata[[1]])){		
		for(i in 1:length(data[[count]]$rawdata)){					#start a loop to go through the Spots
			index=seq(1,length(data[[count]]$rawdata))				#create a index for the number of the Spots
			value.to.compare=data[[count]]$rawdata[[i]][,k]				#choose the Spot to be tested
			others=index[-i]							#choose al the other Spots
			countingindex=0
#sum up the others build a mean out of them	
				for(z in others){
					if(countingindex==0){Sum=data[[count]]$rawdata[[z]][,k]}else{Sum=Sum+data[[count]]$rawdata[[z]][,k]}
					countingindex=countingindex+1
				}
			mean.value.of.the.others=Sum/countingindex
#perform a KS-Test by comparing ech Spot with the mean of the others
			if(i==1){p.for.ID=round(ks.test(value.to.compare,mean.value.of.the.others)$p.value,digits=3)
			}else{p.for.ID=c(p.for.ID,round(ks.test(value.to.compare,mean.value.of.the.others)$p.value,digits=3))}
			}
		IDs.to.keep=(p.for.ID>0)
		IDs=data[[count]]$SpotIDs[IDs.to.keep]
		IDlist[[k]]=IDs
	}

return(IDlist)
}


#################################################################################################################################
#collect and save calibrationdata
#################################################################################################################################

collect.and.save.cal=function(data,chosen.IDs,substance,run){

#search for the data containing the analyte which is suppost to be shown and write the extract the calibrationdata
	for(i in 1:length(data)){
		if(data[[i]]$name==substance){
			count=i
		}
	}
times=data[[count]]$times
concentrations=data[[count]]$concentrations
#go through the argumented data and paste the final tbal together by going through concentrations name and given SpotIDs for each concentration
	zahl=1
	for(column in 1:ncol(data[[count]]$rawdata[[1]])){					#go through concentrations		
#translate IDs to indices		
		nochnezahl=1		
		for(i in 1:length(chosen.IDs[[column]])){						
			if(nochnezahl==1){index=which(data[[count]]$SpotIDs==chosen.IDs[[column]][i])}else{index=c(index,which(data[[count]]$SpotIDs==chosen.IDs[[column]][i]))}
			nochnezahl=nochnezahl+1
		}					 			
#sum everthing up,build a mean and past it together for a new table	 					
		countingindex=0
		for(z in index){
			if(countingindex==0){Sum=data[[count]]$rawdata[[z]][,column]}else{Sum=Sum+data[[count]]$rawdata[[z]][,column]}
			countingindex=countingindex+1
		}					 								 					
		mean.value.of.index=Sum/countingindex		
		if(zahl==1){cal.data=mean.value.of.index}else{cal.data=cbind(cal.data,mean.value.of.index)}
		zahl=zahl+1		
	}
#name and save the resulting data and give them back to the user		
calibration.table=list("name"=substance,"concentrations"=concentrations,"times"=times,"data"=cal.data)	
save(calibration.table,file=paste(gsub("[()/?]","",substance),"calibration.table",run,".RData",sep="_"))	
return(calibration.table)
}


#################################################################################################################################
#create the concentrationtable
#################################################################################################################################

dilutionseries=function(highestconc,dilutions,dilutionfactor){
	for(step in 1:dilutions-1){        #divide the highest concentration several time by 2
		highestconc=cbind(highestconc,highestconc[step]/dilutionfactor)
	}
	concentrations=c(sort(highestconc)) #sort the concentrations to be rising
return(concentrations)
}

#################################################################################################################################
#create the timetable
#################################################################################################################################

timecourse=function(endpoint,measurementinterval){
timepoints=seq(0,endpoint,by=measurementinterval) #create the timeseries by endpoint and interval
return(timepoints[-(1:3)])
}

#################################################################################################################################
#plot a surface showing a first glance of the done calibration experiment
#################################################################################################################################

plotsurface=function(data,substance){ #a function with the arguments of calibrationdata, timeseries, concentrationssetup and the protein og interest

#search for the data containing the analyte which is suppost to be shown and write the extract the calibrationdata
if(length(data)>4){
	for(i in 1:length(data)){
		if(data[[i]]$name==substance){
			count=i
		}
	}
	dataset=data[[count]]$data
	times=data[[count]]$times
	concentrations=data[[count]]$concentrations
}else{
dataset=data$data
times=data$times
concentrations=data$concentrations
}

a=c(times)											#timepoints
b=c(log(concentrations)/log(10)) 								#concentrations logarithmic ("ln")
c=c(dataset)											#convert the dataset into a vector
	
#create the grid for fitting and plotting
	gridmatrix=t(matrix(2,2)) 								#create emtpty matrix    
	for(i in 1:length(b)){   								#go through concentrations
		for(j in 1:length(a)){ 								#go through timepoints
			gridmatrix=rbind(gridmatrix,cbind(a[j],b[i]))
		}
	}
	gridmatrix=gridmatrix[-(1),]
		
	#fit the surface for visual analysis and predict the surface grid in respect to the fitted function "k" with n Gridpoints
	f=predict.surface(Krig( gridmatrix, c,cov.function=Exp.cov,p=2,na.rm=T,m=3,GCV=T,method="GCV.one",lambda=0.02),nx=40,ny=40,extrap=T)

#set parameters for following 3d plots	
open3d()											#open window for plotting
par3d(font=4)											#set the font for all titles and numbers

#plot the simple surface		
	persp3d(	f,									#values to plot
			xlab="Time [min]",							#lable of the x-axis
			ylab="Enzymeconcentrations [ng/ml]",					#lable of the y-axis
			zlab="Intensity",							#lable of the z-axis
			main=paste(substance,"Intensity over Time",sep="  "), 			#lable for the maintitle
			col="red",								#define the layerscolor
			alpha=0.5,								#defines the thickness of lines
			front="lines",								#defines what you see in different points of view
			back="lines",								#defines what you see in different points of view
			axes=F,									#fix the axes
			line=3,									#defines the distanz of lables to axes
			add=F									#dont add to an existing plot
			)[axes3d(edges=c('x','y','z'),color="black",size=1.8)]
	
	persp3d(	a,			
			b,
			c,
			front="points",
			back="points",
			col="blue",
			size=5,						
			alpha=0.5,
			axes=F,
			add=T)
			
}	

#################################################################################################################################
# plot the overlap of calibration experiments
#################################################################################################################################

plotting.overlapping.cals=function(workpath){
analyte=analyte.choice(analyte.names)						#a function with the arguments of workpath, timeseries und concentrationseries
paths=list.files(pattern=paste(gsub("[()/?]","",analyte),"calibration.table",sep="_"))#Sys.glob(file.path(workpath, "*")) 								#creates a list of folders inheriting the timepointsorted data
print(paths)
#open an dreformat all the objects needed

dataset=list()
krigging=list()
surfaces=list()

#load the files and extract their data	
	countingindex=1
		for(files in paths){
			load(files)
			dataset[[countingindex]]=calibration.table$data
			times=calibration.table$times
			concentrations=calibration.table$concentrations
			countingindex=countingindex+1
		}
a=c(times)
b=c(log(concentrations)/log(10))
#create a 2d grid of times and concentrations
	gridmatrix=t(matrix(2,2))
	for(i in 1:length(concentrations)){
		for(j in 1:length(times)){
		gridmatrix=rbind(gridmatrix,cbind(a[j],b[i]))
		}
	}
	gridmatrix=gridmatrix[-(1),]

#set the paramteers fpr the following 3d plots		
open3d()
par3d(cex=1.2)		
par3d(font=4)
par3d(windowRect=c(100,100,1000,900))
farben=rainbow(length(dataset))


#plot the datasetpoints step by step
	for(i in 1:length(dataset)){		
		if(i==1){persp3d(	times,
					log(concentrations)/log(10),	
					dataset[[1]],
					main="rawdata for the different calibration runs",
					xlab="Time [min]",
					ylab="Log(C) of calibrator [ng/ml]",
					zlab="Absorbance",
					extrap=T,
					col=farben[i],
					alpha=0.5,
					front="points",
					back="points",
					size=7,
					axes=F,
					lit=T,
					add=F)[axes3d(edges=c('x','y','z'),color="black",size=1.8)]
		}else{		
			persp3d(	times,
					log(concentrations)/log(10),	
					dataset[[i]],
					col=farben[i],
					alpha=0.5,
					front="points",
					back="points",
					size=7,
					add=T)
		}
	}
windows(title="KOMA: Validation of calibration replicates")
#plot the identifikation plot in colours corresponding to the datasets
	y=rep(1,length(dataset))
	x=seq(1,length(dataset))
	plot(x,y,col=farben,pch=4,cex=4,main="Reject failed calibration replicates by clicking on X",sub="Accept by rightclick->Stop",frame=F,axes=F,ylab="",xlab="")
	if(length(x)>1){
	datasets.to.leeve.out=identify(x, y, labels = rep("O",length(x)), pos = FALSE, plot = TRUE,offset = 0,n=(length(x)-1))
	}else{datasets.to.leeve.out=NULL}
	dev.off()		 	
return(datasets.to.leeve.out)										#return the choosen datasets for leaving them out of calculation
}
#################################################################################################################################
#calculate the arithmetic mean and their standarderror from the replicated experiments 
#################################################################################################################################

calculate.plot.mean.and.error=function(workpath,datasets.to.leeve.out){		#a function with the arguments of workpath, timeseries und concentrationseries and the datasets which are no suppost to be considered
paths=list.files(pattern=paste(gsub("[()/?]","",analyte),"calibration.table",sep="_"))#Sys.glob(file.path(workpath, "*")) 								#creates a list of folders inheriting the timepointsorted data

#create and convert all needed objects	

dataset=list()
krigging=list()
standard=list()
testdata=list()
caldata=list()
		

#load the wanted files and only the wanted ones from the leav.out function before and mean them	
	if(length(datasets.to.leeve.out)>0){
		countingindex=1
		for(files in paths[-(datasets.to.leeve.out)]){
			load(files)
			dataset[[countingindex]]=calibration.table$data
			times=calibration.table$times
			concentrations=calibration.table$concentrations
			if(countingindex==1){Sum=dataset[[countingindex]]}else{Sum=Sum+dataset[[countingindex]]}
			countingindex=countingindex+1
		}
	}else{
		countingindex=1
		for(files in paths){
			load(files)
			dataset[[countingindex]]=calibration.table$data
			times=calibration.table$times
			concentrations=calibration.table$concentrations
			if(countingindex==1){Sum=dataset[[countingindex]]}else{Sum=Sum+dataset[[countingindex]]}
			countingindex=countingindex+1
		}
	}
	a=c(times)
	b=c(log(concentrations)/log(10))
	
	#create a 2d grid of times and concentrations	
		gridmatrix=t(matrix(2,2))
		for(i in 1:length(concentrations)){
			for(j in 1:length(times)){
				gridmatrix=rbind(gridmatrix,cbind(a[j],b[i]))
			}
		}
	gridmatrix=gridmatrix[-(1),]
	
	datasetmean=Sum/(countingindex-1)
	if(length(dataset<2)){dataset[[2]]=dataset[[1]]}
#devide the datasets into to groups a test and a validation dataset			
		caldata.count=sample(1:length(dataset),floor(length(dataset)/2))
		index=(1:length(dataset))[-caldata.count]
		#if(caldata.count==0){
		#				caldata.count=1
		#				}
		
		for(i in 1:length(caldata.count)){
			caldata[[i]]=dataset[[(caldata.count[i])]]
		}
		for(i in 1:length(index)){
			testdata[[i]]=dataset[[(index[i])]]
		}
			
	
#build a mean of the validation dataset	
	countingindex=0
		for(i in 1:length(caldata)){
			if(i==1){Sum=caldata[[i]]}else{Sum=Sum+caldata[[i]]}
			countingindex=countingindex+1
		}
	caldata.mean=Sum/(countingindex)


Observed.curves=matrix(1,length(testdata),ncol(caldata.mean))
#fit and predict the surface for being the validationpart		
	forprediction=predict.surface(Krig( gridmatrix, c(caldata.mean),cov.function=Exp.cov,p=2,na.rm=T,m=3,GCV=T,method="GCV.one",lambda=0.000000001),nx=length(times),ny=2000,extrap=T)	
		 
#perform a testprediction of the concentrations of the analyte (testdataset) by using the validationdataset as calibration		
	for(testcount in 1:length(testdata)){
		for(conc in 1:length(concentrations)){
			topredict=testdata[[testcount]][,conc]
			topredictdist=matrix(1,length(topredict),1) #create empty matrix
			#calculate the euklidean distanze for every column
			for(i in 1:ncol(forprediction$z)){
				topredictdist=cbind(topredictdist,((forprediction$z[,i]-topredict)^2))
			}
			topredictdist=topredictdist[,-(1)]
			topredictmean=matrix(1,1,1)
			for(i in 1:ncol(topredictdist)){
			 	topredictmean=cbind(topredictmean,sqrt(sum(topredictdist[,i])))
		 	}
			topredictmean=topredictmean[,-(1)]
			#predict the unknown concentration and give it out 
			 predictedconc=exp(forprediction$y[which.min(topredictmean)])
			Observed.curves[testcount,conc]=10^(forprediction$y[which.min(topredictmean)])
		}
	}
#paste the results in a matrix and plot everything together, with upper limit and lower limit and meanerror for prediction of a coertain concentration		
	RE=matrix(1,nrow(Observed.curves),ncol(Observed.curves))
	for(observations in 1:nrow(Observed.curves)){
		RE[observations,]=((Observed.curves[observations,]/concentrations)-1)*100
		if(observations==1){
			windows(title="KOMA: Estimation of quantitation limits")
			plot(b,RE[observations,],type="b",ylim=c(-80,80),main="Relative error of quantitation",ylab="relative error [%]",xlab="LOG calibratorcencentration [ng/ml]")
		}else{
			lines(b,RE[observations,],type="b")
		}
	}

x=b
y1=0
y2=0
x1=2
x2=1
y=abs(colMeans(RE))
for(i in 1:(length(y)-2)){
	if(y[i]>25 && y[i+1]<25 && y[i+2]<25){
		y1=y[i]
		y2=y[i+1]
		x1=x[i]
		x2=x[i+1]
	}
}

m=(y1-y2)/(x1-x2)
n=y1-m*x1
lower.limit=(25-n)/m

if(is.na(lower.limit)){
	lower.limit=x[1]
}
if(length(lower.limit)==0){
	lower.limit=x[1]
}
if(lower.limit==Inf){
	lower.limit=x[1]
}


for(i in 3:(length(y))){
	if(y[i]>25 && y[i-1]<25 && y[i-2]<25){
		y1=y[i]
		y2=y[i-1]
		x1=x[i]
		x2=x[i-1]
	}
}

m=(y1-y2)/(x1-x2)
n=y1-m*x1
upper.limit=(25-n)/m

if(is.na(upper.limit)){
	upper.limit=x[length(x)]
}
if(upper.limit==lower.limit){
	upper.limit=x[length(x)]
}
if(upper.limit==Inf){
	upper.limit=x[length(x)]
}

	#fit=predict(Krig(as.matrix(concentrations),colMeans(RE),lambda=0.002),seq(min(concentrations),max(concentrations),by=0.001))
	#upper.limit=seq(min(concentrations),max(concentrations),by=0.001)[which(fit>(-25) & fit<25)][length(which(fit>(-25) & fit<25))]
	#lower.limit=seq(min(concentrations),max(concentrations),by=0.001)[which(fit>(-25) & fit<25)][1]
	lines(rep(upper.limit,length(-100:100)),-100:100,col="green",lty=2,lwd=1.5)
	lines(rep(lower.limit,length(-100:100)),-100:100,col="blue",lty=2,lwd=1.5)
	lines(b,colMeans(RE),type="b",col="red")
	#lines(log(seq(min(concentrations),max(concentrations),length.out=length(fit)))/log(10),fit,type="l",col="red")
	lines(b,rep(25,length(b)))
	lines(b,rep(-25,length(b)))
	legend("topright",c("meanerror","observed error",paste("ULOQ is",round(10^upper.limit,digits=4),"[ng/ml]"),paste("LLOQ is",round(10^lower.limit,digits=4),"[ng/ml]")),col=c("red","black","green","blue"),lty=c(1,1,2,2),lwd=1.5)
		
#calculate the stadarddeviation and the relativ error as a surface dependent on concentration and timepoint
	countingindex=1
	while(countingindex<(length(dataset)+1)){
		standard[[countingindex]]=(dataset[[countingindex]]-datasetmean)^2
		if(countingindex==1){
			Sum=standard[[countingindex]]
		}else{
			Sum=Sum+standard[[countingindex]]
		}
		countingindex=countingindex+1
	}
	standardmean=(Sum/(countingindex-1))^(1/2)
	standarderror=(standardmean/datasetmean)*100
	
	conc.upper=rep(upper.limit,length(times))
	points=seq(0,max(c(datasetmean)),length.out=length(conc.upper))
	matrix.upper=points
	for( i in 1:(length(times)-1)){
		matrix.upper=rbind(matrix.upper,points)
		}
	
	
	conc.lower=rep(lower.limit,length(times))
	points=seq(0,max(c(datasetmean)),length.out=length(conc.lower))
	matrix.lower=points
	for( i in 1:(length(times)-1)){
		matrix.lower=rbind(matrix.lower,points)
	}
	
	


#fit the surface for later prediction of unknown concentrations 
	forprediction=predict.surface(Krig( gridmatrix, c(datasetmean),cov.function=Exp.cov,p=2,na.rm=T,m=3,GCV=T,method="GCV.one",lambda=0.000000001),nx=length(times),ny=2000,extrap=T)
save(forprediction,file=paste(gsub("[()/?]","",calibration.table$name),"forprediction_mean.RData",sep="_"))
write.table(datasetmean,file=paste(gsub("[()/?]","",calibration.table$name),"mean.surface.txt",sep="."),sep="\t")

#fit the surface for plotting the meansurface
	f=predict.surface(Krig( gridmatrix, c(datasetmean),cov.function=Exp.cov,p=2,na.rm=T,m=3,GCV=T,method="GCV.one",lambda=0.001),nx=40,ny=40,extrap=T)
	
#plot the meansurface		
	open3d()
	par3d(cex=1.2)		
	par3d(font=4)
par3d(windowRect=c(100,100,1000,900))

	persp3d(	f,
			xlab="Time [min]",
			ylab="Log(C) of calibrator [ng/ml]",
			zlab="Absorbance",
			main="Mean calibration surface",
			extrap=T,
			col="red",
			alpha=0.5,
			front="lines",
			back="lines",
			axes=F,
			lit=T,
			add=F)[axes3d(edges=c('x','y','z'),color="black",size=1.8)]
	persp3d(	a,			
			b,
			datasetmean,
			front="points",
			back="points",
			col="blue",
			size=5,						
			alpha=0.5,
			axes=F,
			add=T)
	plot3d(		a,			
			conc.upper,
			matrix.upper,
			front="lines",
			back="lines",
			col="green",
			size=5,						
			alpha=0.2,
			axes=F,
			add=T)
	plot3d(		a,			
			conc.lower,
			matrix.lower,
			front="lines",
			back="lines",
			col="blue",
			size=5,						
			alpha=0.2,
			axes=F,
			add=T)
			
#plot the relativ error surface	
f=predict.surface(Krig( gridmatrix, c(standarderror),cov.function=Exp.cov,p=2,na.rm=T,m=3,GCV=T,method="GCV.one",lambda=100),nx=40,ny=40,extrap=T)
	
		open3d()
		par3d(cex=1.2)		
		par3d(font=4)
		
		par3d(windowRect=c(100,100,1000,900))
	
	persp3d(	f,
			xlab="Time [min]",
			ylab="Log(C) of calibrator [ng/ml]",
			zlab="Relative standard deviation [%]",
			main="R.S.D. surface",
			extrap=T,
			col="blue",
			alpha=0.5,
			front="lines",
			back="lines",
			axes=F,
			lit=T,
			add=F)[axes3d(edges=c('x','y','z'),color="black",size=1.8)]
}
#######################################################################################################################################################
#Modules for Analysis of unknown samples which where measured
#
#######################################################################################################################################################

extractdata_unknown_predict_conc=function(workpath,substance){						#creates a function with the argument of workpath, Protein of interest and the calibration run
load(paste(gsub("[()/?]","",substance),"forprediction_mean.RData",sep="_"))

times=forprediction$x


stoffcountingindex=1
rawdaten=list()
confdaten=list()

for(substance in substance){


paths=Sys.glob(file.path(workpath, "*")) 							#creates a list of folders inheriting the timepointsorted data
paths=sort(paths)

a=list()  											#creates empty table
b=list()  											#creates empty table
neu=list()											#creates empty table

foldernames=list.files(path =paths[1])[-length(list.files(path =paths[1]))]


#plot the identifikation plot in colours corresponding to the datasets
	y=rep(1,length(foldernames))
	x=seq(1,length(foldernames))

if(workpath!=wpath || dev.cur()!=2){
	if(dev.cur()>2){dev.off()}
	windows(title="KOMA: Folders with measured data")
	plot(x,y,type="n",pch=4,cex=4,main="choose sample containing folder by clicking on the folders name",axes=F,frame=F,xlab="",ylab="")
	text(x,y,labels=foldernames ,cex=1)
	
	}
	datasets.to.leeve.out=identify(x, y, labels = rep("O",length(x)),col="red", pos = FALSE,n=1, plot = TRUE,offset = 0)
	
foldernames=foldernames[datasets.to.leeve.out]

sampleID.local<<-textstring.entry.window("KOMA: Sample ID","sample ID",sampleID, entryWidth = 50)

for(j in foldernames){                        							#first loop to go through the different folders of concentrations
	m=1
	
	for(i in paths[-(1:3)]){     								#go through timepoints without the first three
		a[[m]]=(read.table(paste(i,paste(j,"\\result.txt",sep=""),sep="\\"),header=T,sep="\t"))[,-(c(5,6,7))]  #reading the tables and cut of unneccessary columns
		
		analyte=(a[[m]][,2]==substance)
		
		SpotIDs=c(a[[m]][analyte,1])
				
		a[[m]]=a[[m]][,-(c(1))]
		
		a[[m]]=a[[m]][analyte,-(c(2))]
		
	m=m+1
	}
	
#go through all the columns an paste rows with equal names together in neu
		
		
			for(g in 1:length(a[[m-1]][,1])){
				neu[[g]]=a[[m-1]][g,]
				for(l in 1:length(paths[-(1:3)])){
						neu[[g]]=rbind(neu[[g]],a[[l]][g,])
				}	
				neu[[g]]=neu[[g]][-(1),]
				}
				
#whrite the different concentrations together in one list		
	b[[j]]=neu
}
#################################################################################################################################
#create table usable for plotting and analysis

d=list()  											#create empty list

#seperate the list entries to the certain datasets

for(r in 1:length(b[[1]])){
	d[[r]]=b[[1]][[r]][,1]
	for(s in 1:length(foldernames)){	
	d[[r]]=cbind(d[[r]],b[[s]][[r]][,2])
	}
	d[[r]]=d[[r]][,-(1)]

	#								#reflect the table and adjust it to rising concentrations

	#d[[r]]=arev(d[[r]],2)

	
}
#save data list, which inheritate the name of the analytes, the Spot IDs and the rawdata
rawdaten[[stoffcountingindex]]=list("name"=substance,"times"=times,"SpotIDs"=SpotIDs,"rawdata"=d)
#Blub=daten[[stoffcountingindex]]
#save(Blub,file=paste(substance,"rawdata",run,".RData",sep="_"))

a=list()  											#creates empty table
b=list()  											#creates empty table
neu=list()											#creates empty table



for(j in foldernames){                        							#first loop to go through the different folders of concentrations
	m=1
	
	for(i in paths[-(1:3)]){     								#go through timepoints without the first three
		a[[m]]=(read.table(paste(i,paste(j,"\\result.txt",sep=""),sep="\\"),header=T,sep="\t"))[,-(c(5,6,7))]  #reading the tables and cut of unneccessary columns
		
		analyte=(a[[m]][,2]==substance)
		
		SpotIDs=c(a[[m]][analyte,1])
				
		a[[m]]=a[[m]][,-(c(1))]
		
		a[[m]]=a[[m]][analyte,-(c(3))]
		
		
	m=m+1
	}
	
	
#go through all the columns an paste rows with equal names together in neu
		
		
			for(g in 1:length(a[[m-1]][,1])){
				neu[[g]]=a[[m-1]][g,]
				for(l in 1:length(paths[-(1:3)])){
						neu[[g]]=rbind(neu[[g]],a[[l]][g,])
				}	
				neu[[g]]=neu[[g]][-(1),]
				}
				
#whrite the different concentrations together in one list		
	b[[j]]=neu
}
#################################################################################################################################
#create table usable for plotting and analysis

d=list()  											#create empty list

#seperate the list entries to the certain datasets

for(r in 1:length(b[[1]])){
	d[[r]]=b[[1]][[r]][,1]
	for(s in 1:length(foldernames)){	
	d[[r]]=cbind(d[[r]],b[[s]][[r]][,2])
	}
	d[[r]]=d[[r]][,-(1)]

	#								#reflect the table and adjust it to rising concentrations

	#d[[r]]=arev(d[[r]],2)

	
}
#save data list, which inheritate the name of the analytes, the Spot IDs and the rawdata
confdaten[[stoffcountingindex]]=list("name"=substance,"times"=times,"SpotIDs"=SpotIDs,"confidence"=d)
#Blub=daten[[stoffcountingindex]]
#save(Blub,file=paste(substance,"rawdata",run,".RData",sep="_"))


IDs.to.go.on=plotting.timecourses.and.choose.IDs.manually(rawdaten[[stoffcountingindex]],substance,confdaten[[stoffcountingindex]],workpath,foldernames)


	zahl=1
	for(column in 1:ncol(as.matrix(rawdaten[[stoffcountingindex]]$rawdata[[1]]))){					#go through concentrations		
#translate IDs to indices		
		nochnezahl=1		
		for(i in 1:length(IDs.to.go.on[[column]])){						
			if(nochnezahl==1){index=which(rawdaten[[stoffcountingindex]]$SpotIDs==IDs.to.go.on[[column]][i])}else{index=c(index,which(rawdaten[[stoffcountingindex]]$SpotIDs==IDs.to.go.on[[column]][i]))}
			nochnezahl=nochnezahl+1
		}					 			
#sum everthing up,build a mean and past it together for a new table	 					
		countingindex=0
		for(z in index){
			if(countingindex==0){Sum=as.matrix(rawdaten[[stoffcountingindex]]$rawdata[[z]])[,column]}else{Sum=Sum+as.matrix(rawdaten[[stoffcountingindex]]$rawdata[[z]])[,column]}
			countingindex=countingindex+1
		}					 								 					
		mean.value.of.index=Sum/countingindex		
		if(zahl==1){mean.data=mean.value.of.index}else{mean.data=cbind(mean.data,mean.value.of.index)}
		zahl=zahl+1		
	}
#name and save the resulting data and give them back to the user		
rawdata.table=list("name"=substance,"times"=times,"data"=mean.data)	



 #########################################################################
 #calculate the euklidean distanze for every column
 #########################################################################
 	topredictdist=matrix(1,length(rawdata.table$data),1) #create empty matrix
 	for(i in 1:ncol(forprediction$z)){
 		topredictdist=cbind(topredictdist,((forprediction$z[,i]-rawdata.table$data)^2))}
 	topredictdist=topredictdist[,-(1)] 
 	topredictmean=matrix(1,1,1) 
 	for(i in 1:ncol(topredictdist)){
  		topredictmean=cbind(topredictmean,sqrt(sum(topredictdist[,i])))}
 	topredictmean=topredictmean[,-(1)]
#predict the unknown concentration and give it out 
 predictedconc=10^(forprediction$y[which.min(topredictmean)])
 
 
 #plot everything together 				
if(plot.graph==TRUE){
	 		open3d()
			par3d(cex=1.2)		
			par3d(font=4)
	
			par3d(windowRect=c(100,100,1000,900))
		persp3d(	forprediction,
	 			xlab="Time [min]",
	 			ylab="Log calibrator conc. [ng/ml]",
	 			zlab="Signal intensity",
	 			main=paste("Unknown sample overlay for",substance,sep="  "),
	 			extrap=T,
	 			col="green",
				size=1.5,
	 			alpha=0.5,
	 			front="points",
	 			back="points",
	 			axes=F,
	 			lit=T,
	 			add=F,
	 			sub=paste("predicted concentration =", predictedconc,"[ng/ml]")
	 			)[axes3d(edges=c('x','y','z'),color="black",size=1.8)]
	 	plot3d(		times
	 			,log(predictedconc)/log(10)
	 			,rawdata.table$data
	 			,col="red"
	 			,size=6
	 			,add=T)
	 	zeroline=rep(0,length(times))
	 	vertical=seq(0,rawdata.table$data[1],length.out=20)
	 	conc.vertical=rep(log(predictedconc)/log(10),length(vertical))
	 	time.vertical=rep(0,length(vertical))
	 	conc.zeroline=rep(log(predictedconc)/log(10),length(zeroline))
	 	plot3d(		time.vertical
	 			,conc.vertical
	 			,vertical
	 			,col="black"
	 			,size=6
	 			,add=T
	 			,type="l")
	 	plot3d(		times
	 			,conc.zeroline
	 			,zeroline
	 			,col="black"
	 			,size=6
	 			,add=T
	 			,type="l")
	}
stoffcountingindex=stoffcountingindex+1
}
return(predictedconc)
}
##########################################################################################################################################################################################################
##########################################################################################################################################################################################################
##########################################################################################################################################################################################################
#########################################################################################################################################################################################################

extractdata_unknown_predict_conc_wholestrip=function(foldernames,paths,substance,workpath){						#creates a function with the argument of workpath, Protein of interest and the calibration run
load(paste(gsub("[()/?]","",substance),"forprediction_mean.RData",sep="_"))

times=forprediction$x


stoffcountingindex=1
rawdaten=list()
confdaten=list()

for(substance in substance){

a=list()  											#creates empty table
b=list()  											#creates empty table
neu=list()											#creates empty table

for(j in foldernames){                        							#first loop to go through the different folders of concentrations
	m=1
	
	for(i in paths[-(1:3)]){     								#go through timepoints without the first three
		a[[m]]=(read.table(paste(i,paste(j,"\\result.txt",sep=""),sep="\\"),header=T,sep="\t"))[,-(c(5,6,7))]  #reading the tables and cut of unneccessary columns
		
		analyte=(a[[m]][,2]==substance)
		
		SpotIDs=c(a[[m]][analyte,1])
				
		a[[m]]=a[[m]][,-(c(1))]
		
		a[[m]]=a[[m]][analyte,-(c(2))]
		
	m=m+1
	}
	
#go through all the columns an paste rows with equal names together in neu
		
		
			for(g in 1:length(a[[m-1]][,1])){
				neu[[g]]=a[[m-1]][g,]
				for(l in 1:length(paths[-(1:3)])){
						neu[[g]]=rbind(neu[[g]],a[[l]][g,])
				}	
				neu[[g]]=neu[[g]][-(1),]
				}
				
#whrite the different concentrations together in one list		
	b[[j]]=neu
}
#################################################################################################################################
#create table usable for plotting and analysis

d=list()  											#create empty list

#seperate the list entries to the certain datasets

for(r in 1:length(b[[1]])){
	d[[r]]=b[[1]][[r]][,1]
	for(s in 1:length(foldernames)){	
	d[[r]]=cbind(d[[r]],b[[s]][[r]][,2])
	}
	d[[r]]=d[[r]][,-(1)]

	#								#reflect the table and adjust it to rising concentrations

	#d[[r]]=arev(d[[r]],2)

	
}
#save data list, which inheritate the name of the analytes, the Spot IDs and the rawdata
rawdaten[[stoffcountingindex]]=list("name"=substance,"times"=times,"SpotIDs"=SpotIDs,"rawdata"=d)
#Blub=daten[[stoffcountingindex]]
#save(Blub,file=paste(substance,"rawdata",run,".RData",sep="_"))

a=list()  											#creates empty table
b=list()  											#creates empty table
neu=list()											#creates empty table



for(j in foldernames){                        							#first loop to go through the different folders of concentrations
	m=1
	
	for(i in paths[-(1:3)]){     								#go through timepoints without the first three
		a[[m]]=(read.table(paste(i,paste(j,"\\result.txt",sep=""),sep="\\"),header=T,sep="\t"))[,-(c(5,6,7))]  #reading the tables and cut of unneccessary columns
		
		analyte=(a[[m]][,2]==substance)
		
		SpotIDs=c(a[[m]][analyte,1])
				
		a[[m]]=a[[m]][,-(c(1))]
		
		a[[m]]=a[[m]][analyte,-(c(3))]
		
		
	m=m+1
	}
	
	
#go through all the columns an paste rows with equal names together in neu
		
		
			for(g in 1:length(a[[m-1]][,1])){
				neu[[g]]=a[[m-1]][g,]
				for(l in 1:length(paths[-(1:3)])){
						neu[[g]]=rbind(neu[[g]],a[[l]][g,])
				}	
				neu[[g]]=neu[[g]][-(1),]
				}
				
#whrite the different concentrations together in one list		
	b[[j]]=neu
}
#################################################################################################################################
#create table usable for plotting and analysis

d=list()  											#create empty list

#seperate the list entries to the certain datasets

for(r in 1:length(b[[1]])){
	d[[r]]=b[[1]][[r]][,1]
	for(s in 1:length(foldernames)){	
	d[[r]]=cbind(d[[r]],b[[s]][[r]][,2])
	}
	d[[r]]=d[[r]][,-(1)]

	#								#reflect the table and adjust it to rising concentrations

	#d[[r]]=arev(d[[r]],2)

	
}
#save data list, which inheritate the name of the analytes, the Spot IDs and the rawdata
confdaten[[stoffcountingindex]]=list("name"=substance,"times"=times,"SpotIDs"=SpotIDs,"confidence"=d)
#Blub=daten[[stoffcountingindex]]
#save(Blub,file=paste(substance,"rawdata",run,".RData",sep="_"))


IDs.to.go.on=plotting.timecourses.and.choose.IDs.manually(rawdaten[[stoffcountingindex]],substance,confdaten[[stoffcountingindex]],workpath,foldernames)


	zahl=1
	for(column in 1:ncol(as.matrix(rawdaten[[stoffcountingindex]]$rawdata[[1]]))){					#go through concentrations		
#translate IDs to indices		
		nochnezahl=1		
		for(i in 1:length(IDs.to.go.on[[column]])){						
			if(nochnezahl==1){index=which(rawdaten[[stoffcountingindex]]$SpotIDs==IDs.to.go.on[[column]][i])}else{index=c(index,which(rawdaten[[stoffcountingindex]]$SpotIDs==IDs.to.go.on[[column]][i]))}
			nochnezahl=nochnezahl+1
		}					 			
#sum everthing up,build a mean and past it together for a new table	 					
		countingindex=0
		for(z in index){
			if(countingindex==0){Sum=as.matrix(rawdaten[[stoffcountingindex]]$rawdata[[z]])[,column]}else{Sum=Sum+as.matrix(rawdaten[[stoffcountingindex]]$rawdata[[z]])[,column]}
			countingindex=countingindex+1
		}					 								 					
		mean.value.of.index=Sum/countingindex		
		if(zahl==1){mean.data=mean.value.of.index}else{mean.data=cbind(mean.data,mean.value.of.index)}
		zahl=zahl+1		
	}
#name and save the resulting data and give them back to the user		
rawdata.table=list("name"=substance,"times"=times,"data"=mean.data)	



 #########################################################################
 #calculate the euklidean distanze for every column
 #########################################################################
 	topredictdist=matrix(1,length(rawdata.table$data),1) #create empty matrix
 	for(i in 1:ncol(forprediction$z)){
 		topredictdist=cbind(topredictdist,((forprediction$z[,i]-rawdata.table$data)^2))}
 	topredictdist=topredictdist[,-(1)] 
 	topredictmean=matrix(1,1,1) 
 	for(i in 1:ncol(topredictdist)){
  		topredictmean=cbind(topredictmean,sqrt(sum(topredictdist[,i])))}
 	topredictmean=topredictmean[,-(1)]
#predict the unknown concentration and give it out 
 predictedconc=10^(forprediction$y[which.min(topredictmean)])
 
 
 #plot everything together 				
if(plot.graph==TRUE){
	 		open3d()
			par3d(cex=1.2)		
			par3d(font=4)
	
			par3d(windowRect=c(100,100,1000,900))
		persp3d(	forprediction,
	 			xlab="Time [min]",
	 			ylab="Log calibrator conc. [ng/ml]",
	 			zlab="Signal intensity",
	 			main=paste("Unknown sample overlay for",substance,sep="  "),
	 			extrap=T,
	 			col="green",
				size=1.5,
	 			alpha=0.5,
	 			front="points",
	 			back="points",
	 			axes=F,
	 			lit=T,
	 			add=F,
	 			sub=paste("predicted concentration =", predictedconc,"[ng/ml]")
	 			)[axes3d(edges=c('x','y','z'),color="black",size=1.8)]
	 	plot3d(		times
	 			,log(predictedconc)/log(10)
	 			,rawdata.table$data
	 			,col="red"
	 			,size=6
	 			,add=T)
	 	zeroline=rep(0,length(times))
	 	vertical=seq(0,rawdata.table$data[1],length.out=20)
	 	conc.vertical=rep(log(predictedconc)/log(10),length(vertical))
	 	time.vertical=rep(0,length(vertical))
	 	conc.zeroline=rep(log(predictedconc)/log(10),length(zeroline))
	 	plot3d(		time.vertical
	 			,conc.vertical
	 			,vertical
	 			,col="black"
	 			,size=6
	 			,add=T
	 			,type="l")
	 	plot3d(		times
	 			,conc.zeroline
	 			,zeroline
	 			,col="black"
	 			,size=6
	 			,add=T
	 			,type="l")
	}
stoffcountingindex=stoffcountingindex+1
}
return(predictedconc)
}
#########################################################################################################################################
#functions fpr GUI use
numeric.entry.window <- function(title, question, entryInit, entryWidth = 20,returnValOnCancel = "ID_CANCEL") {
    dlg <- tktoplevel()
    tkwm.deiconify(dlg)
    tkgrab.set(dlg)
    tkfocus(dlg)
    tkwm.title(dlg, title)
    textEntryVarTcl <- tclVar(paste(entryInit))
    textEntryWidget <- tkentry(dlg, width = paste(entryWidth),textvariable = textEntryVarTcl)
    tkgrid(tklabel(dlg, text = "       "))
    tkgrid(tklabel(dlg, text = question), textEntryWidget)
    tkgrid(tklabel(dlg, text = "       "))
    ReturnVal <- returnValOnCancel

    onOK <- function() {
        ReturnVal <<- as.numeric(tclvalue(textEntryVarTcl))
        tkgrab.release(dlg)
        tkdestroy(dlg)
        tkfocus(mainmenu)
    }
    onCancel <- function() {
        ReturnVal <<- returnValOnCancel
        tkgrab.release(dlg)
        tkdestroy(dlg)
        tkfocus(mainmenu)
    }
    OK.but <- tkbutton(dlg, text = "   OK   ", command = onOK)
    Cancel.but <- tkbutton(dlg, text = " Cancel ", command = onCancel)
    tkgrid(OK.but, Cancel.but)
    tkgrid(tklabel(dlg, text = "    "))

    tkfocus(dlg)
    tkbind(dlg, "<Destroy>", function() {tkgrab.release(dlg); tkfocus(mainmenu)})
    tkbind(textEntryWidget, "<Return>", onOK)
    tkwait.window(dlg)

    return(ReturnVal)
}




textstring.entry.window<- function(title, question, entryInit, entryWidth = 20,returnValOnCancel = "ID_CANCEL") {
    dlg <- tktoplevel()
    tkwm.deiconify(dlg)
    tkgrab.set(dlg)
    tkfocus(dlg)
    tkwm.title(dlg, title)
    textEntryVarTcl <- tclVar(paste(entryInit))
    textEntryWidget <- tkentry(dlg, width = paste(entryWidth),textvariable = textEntryVarTcl)
    tkgrid(tklabel(dlg, text = "       "))
    tkgrid(tklabel(dlg, text = question), textEntryWidget)
    tkgrid(tklabel(dlg, text = "       "))
    ReturnVal <- returnValOnCancel

    onOK <- function() {
        ReturnVal <<- as.character(tclvalue(textEntryVarTcl))
        tkgrab.release(dlg)
        tkdestroy(dlg)
        tkfocus(mainmenu)
    }
    onCancel <- function() {
        ReturnVal <<- returnValOnCancel
        tkgrab.release(dlg)
        tkdestroy(dlg)
        tkfocus(mainmenu)
    }
    OK.but <- tkbutton(dlg, text = "   OK   ", command = onOK)
    Cancel.but <- tkbutton(dlg, text = " Cancel ", command = onCancel)
    tkgrid(OK.but, Cancel.but)
    tkgrid(tklabel(dlg, text = "    "))
	tkraise(dlg)
    tkfocus(dlg)
    tkbind(dlg, "<Destroy>", function() {tkgrab.release(dlg); tkfocus(mainmenu)})
    tkbind(textEntryWidget, "<Return>", onOK)
    tkwait.window(dlg)

    return(ReturnVal)
}
##################################################################################

analyte.choice=function(analyte.names){

analyte.choice<-tktoplevel()
tktitle(analyte.choice)="KOMA: List of analytes"
scr <- tkscrollbar(analyte.choice, repeatinterval=5,command=function(...)tkyview(tl,...))

tl<-tklistbox(analyte.choice,width=40,height=30,selectmode="single",yscrollcommand=function(...)tkset(scr,...),background="white")

tkgrid(tklabel(analyte.choice,text="Select the analyte you want to measure"))

tkgrid(tl,scr)

tkgrid.configure(scr,rowspan=4,sticky="nsw")

analytes <- analyte.names

for (i in (1:length(analytes)))
{
    tkinsert(tl,"end",analytes [i])
}
if(analyte!=1){tkselection.set(tl,which(analyte.names==analyte)-1)}else{tkselection.set(tl,2)}  # Default fruit is Banana.  Indexing starts at zero.

OnOK <- function()
{
	analyte <<- analytes[as.numeric(tkcurselection(tl))+1]
	
    	tkdestroy(analyte.choice)
	
}
OK.but <-tkbutton(analyte.choice,text="   OK   ",command=OnOK)
tkgrid(OK.but)
tkfocus(analyte.choice)
tkwait.window(analyte.choice)

return(analyte)
}




calibrationsettings=function(){
tcl("tk_setPalette","white")
calibwindow=tktoplevel()
#tkwm.deiconify(gase)
tkfocus(calibwindow)
tkwm.title(calibwindow,"Calibration parameters")
tkwm.minsize(calibwindow,300,300)


n_of_conc=tclVar("8")
highest_conc=tclVar("20")
dilution_fact=tclVar("3")
gone_time=tclVar("60")
time_interval=tclVar("1.5")
   
textEntryWidget1 <- tkentry(calibwindow, width = 5,textvariable = n_of_conc)   
textEntryWidget2 <- tkentry(calibwindow, width = 5,textvariable = highest_conc)  
textEntryWidget3 <- tkentry(calibwindow, width = 5,textvariable = dilution_fact)   
textEntryWidget4 <- tkentry(calibwindow, width = 5,textvariable = gone_time)  
textEntryWidget5 <- tkentry(calibwindow, width = 5,textvariable = time_interval)   

tkgrid(tklabel(calibwindow, text = "\n"),sticky="nsw")   
tkgrid(tklabel(calibwindow, text = "Calibrator:"),sticky="nsw")
tkgrid(tklabel(calibwindow, text ="Number of Concentration:"), textEntryWidget1,sticky="nsw")
tkgrid(tklabel(calibwindow, text ="Highest concentration in [ng/ml]:"), textEntryWidget2,sticky="nsw")
tkgrid(tklabel(calibwindow, text ="Dilutionfactor:"), textEntryWidget3,sticky="nsw")
tkgrid(tklabel(calibwindow, text = "       "))
tkgrid(tklabel(calibwindow, text = "Kinetic detection:"),sticky="nsw") 
tkgrid(tklabel(calibwindow, text ="Measurement time:"), textEntryWidget4,sticky="nsw")
tkgrid(tklabel(calibwindow, text ="Interval between measurements:"), textEntryWidget5,sticky="nsw")

ok=function(){
	nofconc=as.numeric(tclvalue(n_of_conc))
	highestconc=as.numeric(tclvalue(highest_conc))
	dilutionfact=as.numeric(tclvalue(dilution_fact))
	gonetime=as.numeric(tclvalue(gone_time))
	timeinterval=as.numeric(tclvalue(time_interval))
	
	concentrations=dilutionseries(	highestconc,nofconc,dilutionfact)
	assign("concentrations", concentrations, envir=.GlobalEnv)
						
	times=timecourse(gonetime,timeinterval)
	assign("times", times, envir=.GlobalEnv)
	tkdestroy(calibwindow)

}

tkgrid(tkbutton(calibwindow,text="OK",command=ok),sticky="nse")
tkfocus(calibwindow)
tkwait.window(calibwindow)
}


}

