calculate.plot.mean.and.error <-
function(workpath,datasets.to.leeve.out){#a function with the arguments of workpath, timeseries und concentrationseries and the datasets which are no suppost to be considered
paths=list.files(pattern=paste(gsub("[()/?]","",analyte),"calibration.table",sep="_")) #creates a list of folders inheriting the timepointsorted data



total=3
progress=0
bar=tkProgressBar(title = "This process could take several seconds", min = 0,max = total, width = 500)
#create and convert all needed objects
setTkProgressBar(bar, progress, label=paste( "confidence interval estimation\t total process",round(progress/total*100,0),"% done"))

dataset=list()
krigging=list()
standard=list()
testdata=list()
caldata=list()


#load the wanted files and only the wanted ones from the leav.out function before and mean them
if(length(datasets.to.leeve.out)>0){
countingindex=1
for(files in paths[-(datasets.to.leeve.out)]){
load(files)
dataset[[countingindex]]=calibration.table$data
times=calibration.table$times
concentrations=calibration.table$concentrations
if(countingindex==1){Sum=dataset[[countingindex]]}else{Sum=Sum+dataset[[countingindex]]}
countingindex=countingindex+1
}
}else{
countingindex=1
for(files in paths){
load(files)
dataset[[countingindex]]=calibration.table$data
times=calibration.table$times
concentrations=calibration.table$concentrations
if(countingindex==1){Sum=dataset[[countingindex]]}else{Sum=Sum+dataset[[countingindex]]}
countingindex=countingindex+1
}
}
a=c(times)
b=c(log(concentrations)/log(10))

#create a 2d grid of times and concentrations
gridmatrix=t(matrix(2,2))
for(i in 1:length(concentrations)){
for(j in 1:length(times)){
gridmatrix=rbind(gridmatrix,cbind(a[j],b[i]))
}
}
gridmatrix=gridmatrix[-(1),]

datasetmean=Sum/(countingindex-1)
if(length(dataset)<2){dataset[[2]]=dataset[[1]]}
#devide the datasets into to groups a test and a validation dataset
caldata.count=sample(1:length(dataset),floor(length(dataset)/2))
index=(1:length(dataset))[-caldata.count]
#if(caldata.count==0){
#caldata.count=1
#}

for(i in 1:length(caldata.count)){
caldata[[i]]=dataset[[(caldata.count[i])]]
}
for(i in 1:length(index)){
testdata[[i]]=dataset[[(index[i])]]
}


#build a mean of the validation dataset
countingindex=0
for(i in 1:length(caldata)){
if(i==1){Sum=caldata[[i]]}else{Sum=Sum+caldata[[i]]}
countingindex=countingindex+1
}
caldata.mean=Sum/(countingindex)


Observed.curves=matrix(1,length(testdata),ncol(caldata.mean))
#fit and predict the surface for being the validationpart
forprediction=predict.surface(Krig( gridmatrix, c(caldata.mean),cov.function=Exp.cov,p=2,na.rm=T,m=3,GCV=T,method="GCV.one",lambda=0.000000001),nx=length(times),ny=2000,extrap=T)
 
#perform a testprediction of the concentrations of the analyte (testdataset) by using the validationdataset as calibration
for(testcount in 1:length(testdata)){
for(conc in 1:length(concentrations)){
topredict=testdata[[testcount]][,conc]
topredictdist=matrix(1,length(topredict),1) #create empty matrix
#calculate the euklidean distanze for every column
for(i in 1:ncol(forprediction$z)){
topredictdist=cbind(topredictdist,((forprediction$z[,i]-topredict)^2))
}
topredictdist=topredictdist[,-(1)]
topredictmean=matrix(1,1,1)
for(i in 1:ncol(topredictdist)){
 topredictmean=cbind(topredictmean,sqrt(sum(topredictdist[,i])))
 }
topredictmean=topredictmean[,-(1)]
#predict the unknown concentration and give it out 
 predictedconc=exp(forprediction$y[which.min(topredictmean)])
Observed.curves[testcount,conc]=10^(forprediction$y[which.min(topredictmean)])
}
}
#paste the results in a matrix and plot everything together, with upper limit and lower limit and meanerror for prediction of a coertain concentration
RE=matrix(1,nrow(Observed.curves),ncol(Observed.curves))
for(observations in 1:nrow(Observed.curves)){
RE[observations,]=((Observed.curves[observations,]/concentrations)-1)*100
if(observations==1){
windows(title="KOMA: Estimation of quantitation limits")
plot(b,RE[observations,],type="b",ylim=c(-80,80),main="Relative error of quantitation",ylab="Relative error [%]",xlab="LOG calibrator concentration [ng/ml]")
}else{
lines(b,RE[observations,],type="b")
}
}
progress=progress+1
setTkProgressBar(bar, progress, label=paste( "mean surface calculation\t total process",round(progress/total*100,0),"% done"))
x=b
y1=0
y2=0
x1=2
x2=1
y=abs(colMeans(RE))
for(i in 1:(length(y)-2)){
if(y[i]>25 && y[i+1]<25 && y[i+2]<25){
y1=y[i]
y2=y[i+1]
x1=x[i]
x2=x[i+1]
}
}

m=(y1-y2)/(x1-x2)
n=y1-m*x1
lower.limit=(25-n)/m

if(is.na(lower.limit)){
lower.limit=x[1]
}
if(length(lower.limit)==0){
lower.limit=x[1]
}
if(lower.limit==Inf){
lower.limit=x[1]
}


for(i in 3:(length(y))){
if(y[i]>25 && y[i-1]<25 && y[i-2]<25){
y1=y[i]
y2=y[i-1]
x1=x[i]
x2=x[i-1]
}
}

m=(y1-y2)/(x1-x2)
n=y1-m*x1
upper.limit=(25-n)/m

if(is.na(upper.limit)){
upper.limit=x[length(x)]
}
if(upper.limit==lower.limit){
upper.limit=x[length(x)]
}
if(upper.limit==Inf){
upper.limit=x[length(x)]
}


lines(rep(upper.limit,length(-100:100)),-100:100,col="green",lty=2,lwd=1.5)
lines(rep(lower.limit,length(-100:100)),-100:100,col="blue",lty=2,lwd=1.5)
lines(b,colMeans(RE),type="b",col="red")
lines(b,rep(25,length(b)))
lines(b,rep(-25,length(b)))
legend("topright",c("Mean error","Observed error",paste("ULOQ is",round(10^upper.limit,digits=4),"[ng/ml]"),paste("LLOQ is",round(10^lower.limit,digits=4),"[ng/ml]")),col=c("red","black","green","blue"),lty=c(1,1,2,2),lwd=1.5)

#calculate the stadarddeviation and the relativ error as a surface dependent on concentration and timepoint
countingindex=1
while(countingindex<(length(dataset)+1)){
standard[[countingindex]]=(dataset[[countingindex]]-datasetmean)^2
if(countingindex==1){
Sum=standard[[countingindex]]
}else{
Sum=Sum+standard[[countingindex]]
}
countingindex=countingindex+1
}
standardmean=(Sum/(countingindex-1))^(1/2)
standarderror=(standardmean/datasetmean)*100

conc.upper=rep(upper.limit,length(times))
points=seq(0,max(c(datasetmean)),length.out=length(conc.upper))
matrix.upper=points
for( i in 1:(length(times)-1)){
matrix.upper=rbind(matrix.upper,points)
}


conc.lower=rep(lower.limit,length(times))
points=seq(0,max(c(datasetmean)),length.out=length(conc.lower))
matrix.lower=points
for( i in 1:(length(times)-1)){
matrix.lower=rbind(matrix.lower,points)
}




#fit the surface for later prediction of unknown concentrations 
forprediction=predict.surface(Krig( gridmatrix, c(datasetmean),cov.function=Exp.cov,p=2,na.rm=T,m=3,GCV=T,method="GCV.one",lambda=0.000000001),nx=length(times),ny=2000,extrap=T)
save(forprediction,file=paste(gsub("[()/?]","",calibration.table$name),"forprediction_mean.RData",sep="_"))
write.table(datasetmean,file=paste(gsub("[()/?]","",calibration.table$name),"mean.surface.txt",sep="."),sep="\t")

#fit the surface for plotting the meansurface
f=predict.surface(Krig( gridmatrix, c(datasetmean),cov.function=Exp.cov,p=2,na.rm=T,m=3,GCV=T,method="GCV.one",lambda=0.001),nx=40,ny=40,extrap=T)

#plot the meansurface
open3d()
par3d(cex=1.2)
par3d(font=4)
par3d(windowRect=c(100,100,1000,900))

persp3d(f,
xlab="Time [min]",
ylab="Log(C) of calibrator [ng/ml]",
zlab="Absorbance",
main="Mean calibration surface",
extrap=T,
col="red",
alpha=0.5,
front="lines",
back="lines",
axes=F,
lit=T,
add=F)[axes3d(edges=c('x','y','z'),color="black",size=1.8)]
persp3d(a,
b,
datasetmean,
front="points",
back="points",
col="blue",
size=5,
alpha=0.5,
axes=F,
add=T)
plot3d(a,
conc.upper,
matrix.upper,
front="lines",
back="lines",
col="green",
size=5,
alpha=0.2,
axes=F,
add=T)
plot3d(a,
conc.lower,
matrix.lower,
front="lines",
back="lines",
col="blue",
size=5,
alpha=0.2,
axes=F,
add=T)
progress=progress+1
setTkProgressBar(bar, progress, label=paste( "standarderror estimation\t total process",round(progress/total*100,0),"% done"))
#plot the relativ error surface
f=predict.surface(Krig( gridmatrix, c(standarderror),cov.function=Exp.cov,p=2,na.rm=T,m=3,GCV=T,method="GCV.one",lambda=100),nx=40,ny=40,extrap=T)

open3d()
par3d(cex=1.2)
par3d(font=4)

par3d(windowRect=c(100,100,1000,900))

persp3d(f,
xlab="Time [min]",
ylab="Log(C) of calibrator [ng/ml]",
zlab="Relative standard deviation [%]",
main="R.S.D. surface",
extrap=T,
col="blue",
alpha=0.5,
front="lines",
back="lines",
axes=F,
lit=T,
add=F)[axes3d(edges=c('x','y','z'),color="black",size=1.8)]
progress=progress+1
setTkProgressBar(bar, progress, label=paste( "standarderror estimation\t total process",round(progress/total*100,0),"% done"))
close(bar)
}

